//: version "V0.9"
//: property discardChanges = 1

module main;    //: root_module
supply1 w17;    //: /sn:0 {0}(620,315)(620,292){1}
supply0 w14;    //: /sn:0 {0}(654,415)(654,436)(603,436){1}
//: {2}(599,436)(566,436)(566,415){3}
//: {4}(601,438)(601,455){5}
supply0 w13;    //: /sn:0 {0}(650,191)(650,213)(608,213){1}
//: {2}(604,213)(571,213)(571,191){3}
//: {4}(606,215)(606,231){5}
supply1 w12;    //: /sn:0 {0}(625,86)(625,63){1}
wire R;    //: /dp:3 {0}(606,353)(535,353){1}
//: {2}(531,353)(442,353){3}
//: {4}(533,355)(533,406)(552,406){5}
wire S;    //: /dp:3 {0}(611,94)(591,94){1}
//: {2}(587,94)(436,94){3}
//: {4}(589,96)(589,182)(636,182){5}
wire w16;    //: /sn:0 {0}(620,345)(620,332){1}
wire w6;    //: /sn:0 {0}(625,119)(625,103){1}
wire Q;    //: /dp:3 {0}(654,398)(654,385){1}
//: {2}(656,383)(753,383){3}
//: {4}(654,381)(654,273)(532,273)(532,184){5}
//: {6}(534,182)(557,182){7}
//: {8}(532,180)(532,127)(611,127){9}
//: {10}(652,383)(622,383){11}
//: {12}(620,381)(620,362){13}
//: {14}(618,383)(566,383)(566,398){15}
wire _Q;    //: /dp:7 {0}(571,174)(571,159)(623,159){1}
//: {2}(627,159)(648,159){3}
//: {4}(652,159)(690,159){5}
//: {6}(694,159)(748,159){7}
//: {8}(692,161)(692,252)(584,252)(584,321){9}
//: {10}(586,323)(606,323){11}
//: {12}(584,325)(584,406)(640,406){13}
//: {14}(650,161)(650,174){15}
//: {16}(625,157)(625,136){17}
//: enddecls

  //: comment g27 @(25,193) /anc:1
  //: /line:"2) Press the space bar 10 to 20 times to"
  //: /line:"advance the simulator.  Note that both the"
  //: /line:"\"Q\" and \"_Q\" signals are in the unknown state."
  //: /line:"Now turn on the \"S\" switch (by clicking on it)"
  //: /line:"and press the space bar another 10 to 20"
  //: /line:"times.  The \"Q\" signal will go high and the"
  //: /line:"\"_Q\" signal will go low."
  //: /line:""
  //: /end
  //: comment g26 @(26,101) /anc:1
  //: /line:"1) Begin the simulation by clicking on the"
  //: /line:"\"Play\" button or by selecting \"Begin"
  //: /line:"Simulation\" from the \"Simulate\" menu."
  //: /line:"Set Probes on the \"S\", \"R\", \"Q\" and \"_Q\""
  //: /line:"signals by double-clicking them.  The \"_Q\""
  //: /line:"signal is the \"Q\" with an overline."
  //: /end
  //: comment g25 @(35,22) /anc:1
  //: /line:"This circuit is a simple flip-flop composed"
  //: /line:"of two CMOS NOR gates implemented at the"
  //: /line:"transistor level."
  //: /end
  //: joint g21 (Q) @(532, 182) /anc:1 /w:[ 6 8 -1 5 ]
  //: joint g10 (Q) @(654, 383) /anc:1 /w:[ 2 4 10 1 ]
  //: joint g7 (Q) @(620, 383) /anc:1 /w:[ 11 12 14 -1 ]
  //: joint g24 (_Q) @(625, 159) /anc:1 /w:[ 2 16 1 -1 ]
  //: joint g23 (_Q) @(650, 159) /anc:1 /w:[ 4 -1 3 14 ]
  //: joint g9 (_Q) @(692, 159) /anc:1 /w:[ 6 -1 5 8 ]
  //: joint g18 (_Q) @(584, 323) /anc:1 /w:[ 10 9 -1 12 ]
  //: joint g22 (R) @(533, 353) /anc:1 /w:[ 1 -1 2 4 ]
  //: joint g20 (w14) @(601, 436) /anc:1 /w:[ 1 -1 2 4 ]
  //: switch g19 (R) @(425,353) /sn:0 /anc:1 /w:[ 3 ] /st:0
  //: supply0 g17 (w14) @(601,461) /sn:0 /anc:1 /w:[ 5 ]
  //: supply1 g16 (w17) @(631,292) /sn:0 /anc:1 /w:[ 1 ]
  pmos g15 (.Z(w17), .S0(w16), .G0(_Q));   //: @(614,323) /sn:0 /anc:1 /w:[ 0 1 11 ]
  pmos g14 (.Z(w16), .S0(Q), .G0(R));   //: @(614,353) /sn:0 /anc:1 /w:[ 0 13 0 ]
  nmos g13 (.Z(w14), .S0(Q), .G0(_Q));   //: @(648,406) /sn:0 /anc:1 /w:[ 0 0 13 ]
  nmos g12 (.Z(w14), .S0(Q), .G0(R));   //: @(560,406) /sn:0 /anc:1 /w:[ 3 15 5 ]
  //: joint g11 (S) @(589, 94) /anc:1 /w:[ 1 -1 2 4 ]
  //: joint g8 (w13) @(606, 213) /anc:1 /w:[ 1 -1 2 4 ]
  //: switch g6 (S) @(419,94) /sn:0 /anc:1 /w:[ 3 ] /st:0
  //: supply0 g5 (w13) @(606,237) /sn:0 /anc:1 /w:[ 5 ]
  //: supply1 g4 (w12) @(636,63) /sn:0 /anc:1 /w:[ 1 ]
  pmos g3 (.Z(w12), .S0(w6), .G0(S));   //: @(619,94) /sn:0 /anc:1 /w:[ 0 1 0 ]
  pmos g2 (.Z(w6), .S0(_Q), .G0(Q));   //: @(619,127) /sn:0 /anc:1 /w:[ 0 17 9 ]
  nmos g1 (.Z(w13), .S0(_Q), .G0(S));   //: @(644,182) /sn:0 /anc:1 /w:[ 0 15 5 ]
  nmos g0 (.Z(w13), .S0(_Q), .G0(Q));   //: @(565,182) /sn:0 /anc:1 /w:[ 3 0 7 ]
  //: comment g28 @(26,299) /anc:1
  //: /line:"3) Return the \"S\" switch to the off position"
  //: /line:"and press the space bar 10 to 20 times.  The"
  //: /line:"\"Q\" and \"_Q\" signals will remain constant."
  //: /end
  //: comment g29 @(26,355) /anc:1
  //: /line:"4) Now turn the \"R\" switch off by clicking"
  //: /line:"on it and press the space bar 10 to 20 times."
  //: /line:"The \"_Q\" signal will go high and the \"Q\""
  //: /line:"signal will go low."
  //: /end
  //: comment g30 @(23,420) /anc:1
  //: /line:"5) Return the \"R\" switch to the off position"
  //: /line:"and press the space bar 10 to 20 times.  The"
  //: /line:"\"Q\" and \"_Q\" signals will remain constant."
  //: /end

endmodule
