//: version "1.0"
//: property discardChanges = 1

module main;    //: root_module
wire w2;    //: /sn:0 {0}(694,193)(648,193){1}
wire w5;    //: /sn:0 {0}(739,229)(725,229)(725,196)(715,196){1}
wire w6;    //: /sn:0 {0}(739,234)(684,234){1}
//: {2}(682,232)(682,198)(694,198){3}
//: {4}(680,234)(648,234){5}
wire w7;    //: /sn:0 {0}(760,232)(770,232){1}
//: enddecls

  //: frame g13 @(411,350) /sn:0 /anc:1 /wi:376 /ht:200 /tx:"Create Circuit Here"
  //: comment g11 @(10,296) /anc:1
  //: /line:"4) Connect the upper input wire of the OR gate to the output of the AND gate by clicking and holding the"
  //: /line:"free end of the AND gate output with the left mouse button.  This will causethe mouse cursor to change to"
  //: /line:"a soldering iron.  Now drag the wire near the end of the upper input wire on the OR gate and release the"
  //: /line:"mouse button.  The wires will \"click\" together."
  //: /line:""
  //: /end
  //: comment g10 @(12,354) /anc:1
  //: /line:"5) Create the two switches the same way as the"
  //: /line:"AND and OR gates, by setting a position and selecting"
  //: /line:"\"Switch\" from the \"Switch\" submenu of the \"Make\""
  //: /line:"menu, or by typing an \"s\"."
  //: /line:""
  //: /line:"6) Repeat step 4 to connect the output of the upper"
  //: /line:"switch to the upper input of the AND gate."
  //: /line:""
  //: /line:"7) Repeat step 4 to connect the output of the lower"
  //: /line:"switch to the lower input of the OR gate."
  //: /line:""
  //: /line:"8) Click and hold on the lower input of the AND gate"
  //: /line:"to bring up the soldering iron.  Drag it down to the"
  //: /line:"middle of the wire connecting the lower switch and the"
  //: /line:"OR gate and release the mouse button.  A solder joint"
  //: /line:"will be automatically created."
  //: /end
  //: comment g0 @(6,5) /anc:1
  //: /line:"This is a brief tutorial on how to use TkGate.  Follow the steps in the order in which they are numbered to"
  //: /line:"create a simple circuit.  After you have finished, open the \"Help\" menu, go into the \"Tutorials\" submenu and"
  //: /line:"select \"Editing a Circuit (1)\" for the next tutorial."
  //: /line:""
  //: /line:"   * This tutorial appears automatically when first starting TkGate.  You can disable it by selecting"
  //: /line:"     \"Options...\" from the \"File\" menu and turning off \"Novice Mode\"."
  //: /line:""
  //: /line:"   * You can create a new circuit from scratch by selecting \"New\" from the \"File\" menu or load a circuit from"
  //: /line:"     a file by selecting \"Open...\" from the \"File\" menu."
  //: /line:""
  //: /line:"   * See http://www.cs.cmu.edu/~hansen/tkgate for complete TkGate documentation."
  //: /line:""
  //: /end
  //: switch g1 (w2) @(631,193) /sn:0 /anc:1 /w:[ 1 ] /st:0
  //: switch g2 (w6) @(631,234) /sn:0 /anc:1 /w:[ 5 ] /st:0
  and g3 (.I0(w2), .I1(w6), .Z(w5));   //: @(705,196) /sn:0 /anc:1 /w:[ 0 3 1 ]
  or g4 (.I0(w5), .I1(w6), .Z(w7));   //: @(750,232) /sn:0 /anc:1 /w:[ 0 0 0 ]
  //: joint g5 (w6) @(682, 234) /anc:1 /w:[ 1 2 4 -1 ]
  //: comment g6 @(608,159) /anc:1
  //: /line:"Switches"
  //: /end
  //: comment g7 @(700,173) /anc:1
  //: /line:"AND gate"
  //: /end
  //: comment g8 @(757,213) /anc:1
  //: /line:"OR gate"
  //: /end
  //: comment g9 @(10,147) /anc:1
  //: /line:"1) In this example, you will build a circuit like the one shown on the right."
  //: /line:"Build your circuit in the blank area in the lower right corner of this window."
  //: /line:"Start by setting a position for the AND gate by clicking the right mouse"
  //: /line:"button.  An \"X\" symbol will appear to mark the position."
  //: /line:""
  //: /line:"2) Now select \"AND\" from the \"Gates\" submenu of the \"Make\" menu on the menu"
  //: /line:"bar to create an AND gate at the position you selected.  Alternatively, you"
  //: /line:"can use the keyboard shortcut \"a\"."
  //: /line:""
  //: /line:"3) Now repeat the action, this time selecting a postion for the OR gate, placing"
  //: /line:"it to the right and below the position of the AND gate.  Create the OR gate by"
  //: /line:"selecting \"OR\" from the \"Gates\" submenu of the \"Mark\" menu, or by typing an \"o\"."
  //: /line:""
  //: /line:""
  //: /end

endmodule
