//: version "V0.9"
//: property discardChanges = 1

module main;    //: root_module
wire w3;    //: /sn:0 {0}(480,419)(462,419)(462,184)(432,184){1}
wire w5;    //: /sn:0 {0}(501,422)(511,422){1}
wire w2;    //: /sn:0 {0}(73,181)(411,181){1}
wire w6;    //: /sn:0 {0}(73,424)(336,424){1}
//: {2}(340,424)(480,424){3}
//: {4}(338,422)(338,186)(411,186){5}
//: enddecls

  //: comment g5 @(473,437) /anc:1
  //: /line:"6) Open the \"Tool\" menu and select"
  //: /line:"\"Move/Connect\" to return to the basic"
  //: /line:"editing tool.  Now double click on the"
  //: /line:"OR gate here to open the properties"
  //: /line:"box for the gate.  You can change the"
  //: /line:"name of the gate, make the name visible"
  //: /line:"by undoing the \"hide\" option, and add"
  //: /line:"or delete ports."
  //: /end
  //: comment g3 @(473,286) /anc:1
  //: /line:"5) Open the \"Tool\" menu and select \"Bit"
  //: /line:"Width\" to bring up the ribbon cable tool."
  //: /line:"This will also cause a text entry labeled"
  //: /line:"\"Bits:\" to appear in the lower right corner"
  //: /line:"of the main window.  Click in the entry"
  //: /line:"box and enter a number between 1 and 32."
  //: /line:"Now click on a wire to set it to the"
  //: /line:"indicated bit width."
  //: /end
  //: comment g11 @(42,353) /anc:1
  //: /line:"4) Open the \"Tool\" menu and select"
  //: /line:"\"Delete Gate\" to bring up the IC"
  //: /line:"extractor tool. Click on the switch"
  //: /line:"here to delete it."
  //: /end
  //: comment g10 @(456,115) /anc:1
  //: /line:"3) Open the \"Tool\" menu and select \"Invert\""
  //: /line:"to bring up the inverting tool.  Click the"
  //: /line:"inverter bubble near the input or output "
  //: /line:"of a gate to add or delete an inverter."
  //: /end
  //: comment g9 @(128,99) /anc:1
  //: /line:"2) Open the \"Tool\" menu and select \"Cut"
  //: /line:"Wire\" to bring up the wire cutter tool."
  //: /line:"Click the wire cutter somewhere along"
  //: /line:"this wire to cut it.  Loose segments"
  //: /line:"or segments leading to a joint will be"
  //: /line:"automatically cleaned up."
  //: /end
  //: comment g2 @(467,195) /anc:1
  //: /line:"1) Click on the AND gate with the left"
  //: /line:"mouse button.  Try dragging the gate to"
  //: /line:"a new position and watch how the wires"
  //: /line:"move with the gate."
  //: /end
  //: comment g0 @(32,28) /anc:1
  //: /line:"This tutorial introduces the basic editing features of TkGate.  Follow the steps in the"
  //: /line:"order indicated.  When you have completed this task, select \"Editing a Circuit (2)\""
  //: /line:"from the \"Tutorials\" submenu of the \"Help\" menu."
  //: /end
  and g1 (.I0(w2), .I1(w6), .Z(w3));   //: @(422,184) /sn:0 /anc:1 /w:[ 1 5 1 ]
  or g4 (.I0(w3), .I1(w6), .Z(w5));   //: @(491,422) /sn:0 /anc:1 /w:[ 0 3 0 ]
  //: switch g6 (w2) @(56,181) /sn:0 /anc:1 /w:[ 0 ] /st:0
  //: switch g7 (w6) @(56,424) /sn:0 /anc:1 /w:[ 0 ] /st:0
  //: joint g8 (w6) @(338, 424) /anc:1 /w:[ 2 4 1 -1 ]
  //: comment g12 @(84,191) /anc:1
  //: /line:"7) Double click on a wire to open"
  //: /line:"the wire properties box.  You can"
  //: /line:"change the signal name, make the"
  //: /line:"signal name visible, or set the"
  //: /line:"bit width of the wire."
  //: /end

endmodule
