//: version "V0.9"
//: property discardChanges = 1

module foo();
//: interface  /sz:(40, 40) /bd:[ ]
//: enddecls

  //: comment g0 @(31,31)
  //: /line:"10) This is the definition for the \"foo\""
  //: /line:"module.  The \"ports\" list in the lower left"
  //: /line:"corner of the main window indicates the"
  //: /line:"the ports that we defined on the default"
  //: /line:"module instance.  To create an internal"
  //: /line:"reference to a port, click the mouse to"
  //: /line:"set a mark and select \"Module Input\","
  //: /line:"\"Module Output\" or \"Module InOut\" from the"
  //: /line:"\"Module\" submenu of the \"Make\" menu.  A"
  //: /line:"dialog box will appear allowing you to set"
  //: /line:"the name of the port.  Enter a name and press"
  //: /line:"return."
  //: /line:""
  //: /line:"11) You can also create a new module"
  //: /line:"definition without creating an instance"
  //: /line:"by selecting \"New...\" from the \"Module\""
  //: /line:"menu.  This will bring up a dialog box"
  //: /line:"prompting for a module name.  Try entering"
  //: /line:"\"bar\" and pressing return."
  //: /line:""
  //: /line:"12) You can rename, copy and delete modules"
  //: /line:"using the other command in the \"Module\""
  //: /line:"menu."
  //: /line:""
  //: /line:"13) If you opened this block by double-clicking"
  //: /line:"on \"foo\" in the module list, you can return"
  //: /line:"to the main module by double-clicking on"
  //: /line:"\"main\". If you opened this block by using the"
  //: /line:"\"Open\" command from the \"Module\" menu, you"
  //: /line:"can return to the next level up by selecting"
  //: /line:"\"Close\" from the \"Module\" menu or by double-"
  //: /line:"clicking on main."
  //: /end
  //: frame g1 @(381,30) /sn:0 /wi:396 /ht:230 /tx:"Create Module Ports Here"

endmodule

module main;    //: root_module
//: enddecls

  //: frame g2 @(432,68) /sn:0 /anc:1 /wi:356 /ht:213 /tx:"Use this space to create a module instance"
  //: comment g0 @(22,9) /anc:1
  //: /line:"This tutorial describes the use of modules in TkGate.  Follow the steps in the"
  //: /line:"order indicated.  When you have completed this task, select \"Simulating a Circuit\""
  //: /line:"from the \"Tutorials\" submenu of the \"Help\" menu."
  //: /end
  //: comment g1 @(25,75) /anc:1
  //: /line:"1) Click the left mouse button in the center of the"
  //: /line:"blank area to the left of this text block to set a"
  //: /line:"position.  Now select \"Module Instance\" from the"
  //: /line:"\"Module\" submenu of the \"Make\" menu to create a"
  //: /line:"module instance.  A dialog box will appear with the"
  //: /line:"entry for \"Function\" active.  Enter \"foo\" in lower"
  //: /line:"case and hit return to set the type of the instance"
  //: /line:"to \"foo\"."
  //: /line:""
  //: /line:"2) Press the left mouse button near the lower right"
  //: /line:"corner of the module instance and drag it down and"
  //: /line:"to the right to increase the size of the box."
  //: /line:""
  //: /line:"3) While the block is still selected, select \"Add"
  //: /line:"Input\" from the \"Gate\" menu.  A special add-input"
  //: /line:"cursor will appear.  Now click the left mouse button"
  //: /line:"near the left edge of the block to add a new input."
  //: /line:"A dialog box will appear with the entry for \"Port"
  //: /line:"Name\" active.  Type an \"A\" and press return.  Now"
  //: /line:"repeat the process to add input \"B\" and \"C\" on the"
  //: /line:"same side.  Repeat the process again, this time"
  //: /line:"selecting \"Add Output\" and creating outputs \"X\","
  //: /line:"\"Y\" and \"Z\" on the right side of the block."
  //: /line:""
  //: /line:"4) Try clicking on one of the ports you added near the"
  //: /line:"edge of the module.  You can drag them along the edge"
  //: /line:"they are attached to change their position."
  //: /line:""
  //: /line:"5) Select the module instance again and select \"Change"
  //: /line:"Type\" from the \"Gate\" menu.  Click on the \"A\" port"
  //: /line:"near the edge of the block. This will change the"
  //: /line:"direction of the port which is indicated by the small"
  //: /line:"arrow.  You can repeat this action to cycle through"
  //: /line:"the three port types: input, output, and inout."
  //: /line:""
  //: /line:"6) Select \"Cut Wire\" from the \"Tool\" menu and click on"
  //: /line:"the \"Z\" wire near the edge of the module instance."
  //: /line:"This will delete the port."
  //: /end
  //: comment g6 @(436,296) /anc:1
  //: /line:"7) Select \"Move/Connect\" from the \"Tool\""
  //: /line:"menu to return to the default editing mode."
  //: /line:"Now select a new position with the mouse"
  //: /line:"and create a new module instance named \"foo\"."
  //: /line:"Note that the instance size and wire postions"
  //: /line:"are not copied."
  //: /line:""
  //: /line:"8) Now select the instance of \"foo\" to which"
  //: /line:"you added input and output ports and select"
  //: /line:"\"Set Interface\" from the \"Module\" menu."
  //: /line:"Create another instance of a \"foo\" module."
  //: /line:"Note that the wire interface is now"
  //: /line:"duplicated for each \"foo\" you create."
  //: /line:""
  //: /line:"9) Now \"open\" the module instance you created."
  //: /line:"You can do this either by selecting the \"foo\""
  //: /line:"module instance and then selecting \"Open\" from"
  //: /line:"the \"Module\" menu, or by double-clicking on"
  //: /line:"\"foo\" in the module list on the left side of"
  //: /line:"the main window."
  //: /end

endmodule
