//: version "V0.9"

module main;    //: root_module
wire C;    //: {0}(663,263)(707,263){1}
wire S;    //: {0}(662,200)(704,200){1}
wire w3;    //: /sn:0 {0}(579,120)(601,120)(601,195){1}
//: {2}(603,197)(641,197){3}
//: {4}(601,199)(601,223){5}
wire w4;    //: /sn:0 {0}(544,199)(512,199){1}
//: {2}(510,197)(510,179)(478,179){3}
//: {4}(510,201)(510,262)(549,262){5}
wire w5;    //: /sn:0 {0}(479,227)(499,227){1}
//: {2}(501,225)(501,204)(544,204){3}
//: {4}(501,229)(501,267)(549,267){5}
wire w1;    //: /sn:0 {0}(641,202)(598,202){1}
//: {2}(594,202)(565,202){3}
//: {4}(596,204)(596,223){5}
wire w0;    //: /sn:0 {0}(642,260)(599,260)(599,244){1}
wire w6;    //: /sn:0 {0}(642,265)(570,265){1}
//: enddecls

  //: comment g19 @(421,301) /anc:1
  //: /line:"7) Press \"play\" button from the button"
  //: /line:"bar again, or select \"Run\" from the \"Simulate\""
  //: /line:"menu.  This will cause the simulator to enter"
  //: /line:"a continuous simulation mode.  Try clicking"
  //: /line:"on the switches in the circuit.  Each time"
  //: /line:"you change a switch, the simulation will"
  //: /line:"continue until the outputs are stable."
  //: /line:""
  //: /line:"8) To end the simulation, press the \"stop\""
  //: /line:"button on the button bar, or select \"End"
  //: /line:"Simulation\" from the \"Simulate\" menu."
  //: /end
  //: comment g13 @(37,78) /anc:1
  //: /line:"1) Press the \"play\" button from the button"
  //: /line:"bar above, or select \"Begin Simulation\" from"
  //: /line:"the \"Simulate\" menu.  The simulation scope"
  //: /line:"window should appear."
  //: /line:""
  //: /line:"2) Set a probe on the two on the two wires"
  //: /line:"labeled \"S\" and \"C\" and on the wire leading"
  //: /line:"out of each of the switches by double-clicking"
  //: /line:"on them.  A trace for each of the signals"
  //: /line:"will appear in the scope window."
  //: /line:""
  //: /line:"3) Hit the space bar several times to advance"
  //: /line:"the simulation time.  Each press of the space"
  //: /line:"bar will advance the simulation time by one"
  //: /line:"epoch.  An epoch is the smallest unit of time"
  //: /line:"understood by the simulator."
  //: /line:""
  //: /line:"4) Select \"Options...\" from the \"File\""
  //: /line:"menu.  Enter \"5\" in the entry for \"Epoch"
  //: /line:"Step Size\" and hit \"OK\".  Now try hitting"
  //: /line:"the space bar.  Each press will advance the"
  //: /line:"simulator by 5 epochs."
  //: /line:""
  //: /line:"5) Click on one of the switches to change"
  //: /line:"its value and hit the space bar several times"
  //: /line:"to advance the simulator.  The results of the"
  //: /line:"simulation should appear in the scope window."
  //: /line:""
  //: /line:"6) Press and hold the left mouse button on any"
  //: /line:"of the internal wires to view its value.  The"
  //: /line:"value is displayed in \"Verilog\" format."
  //: /line:"The first number indicates the bit width,"
  //: /line:"the letter indicates the radix, and the last"
  //: /line:"number the value.  For example, the \"1\" in"
  //: /line:"\"1'b0\" indicates that this is a 1-bit value,"
  //: /line:"the \"b\" indicates the value is given in binary,"
  //: /line:"and the \"0\" indicates the value of the signal."
  //: /end
  //: switch g0 (w4) @(461,179) /sn:0 /anc:1 /w:[ 3 ] /st:0
  //: switch g1 (w5) @(462,227) /sn:0 /anc:1 /w:[ 0 ] /st:0
  //: switch g3 (w3) @(562,120) /sn:0 /anc:1 /w:[ 0 ] /st:0
  xor g4 (.I0(w4), .I1(w5), .Z(w1));   //: @(555,202) /sn:0 /anc:1 /w:[ 0 3 3 ]
  nand g2 (.I0(w4), .I1(w5), .Z(w6));   //: @(560,265) /sn:0 /anc:1 /w:[ 5 5 1 ]
  //: joint g5 (w4) @(510, 199) /anc:1 /w:[ 1 2 -1 4 ]
  //: joint g6 (w5) @(501, 227) /anc:1 /w:[ -1 2 1 4 ]
  xor g7 (.I0(w3), .I1(w1), .Z(S));   //: @(652,200) /sn:0 /anc:1 /w:[ 3 0 0 ]
  nand g8 (.I0(w0), .I1(w6), .Z(C));   //: @(653,263) /sn:0 /anc:1 /w:[ 0 0 0 ]
  nand g9 (.I0(w1), .I1(w3), .Z(w0));   //: @(599,234) /sn:0 /R:3 /anc:1 /w:[ 5 5 1 ]
  //: joint g10 (w3) @(601, 197) /anc:1 /w:[ 2 1 -1 4 ]
  //: joint g11 (w1) @(596, 202) /anc:1 /w:[ 1 -1 2 4 ]
  //: comment g12 @(41,23) /anc:1
  //: /line:"This tutorial introduces the fundamentals of simulating a circuit in TkGate."
  //: /line:"Only a simple example is presented here.  More complex examples can be viewed"
  //: /line:"under the \"Examples\" submenu of the \"Help\" menu."
  //: /end

endmodule
