#   Copyright (C) 1987-1999 by Jeffery P. Hansen
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Last edit by hansen on Fri Oct  8 17:30:11 1999
#

set find_type 3
set find_target ""

set edgat_wires {}
set edgat_wops {}
set edgat_type "huh?"
set edgat_name "huh?"
set edgat_hideName 1
set edgat_anchor 0
set edgat_xpos 0
set edgat_ypos 0
set edgat_blockFunc "huh?"
set edgat_newBlock 0
set edgat_newPort 0
set edgat_geom "+0+0"
set ecpOmega 100
set ecpPhi 50
set ecpDuty 50
set edgat_switch 0
set edgat_dip 0
set edgat_tap 0
set edgat_memFile ""
set edgat_ok 0
set edgat_commentLen 0

set edport_ok 0
set edport_idx 0
set edport_sig "huh"
set edport_port "huh"
set edport_basePort "huh"
set edport_type "huh"
set edport_bits "huh"

set clkFrame [list]

proc edgatPortView args {
  eval ".edgat.io.box.name.lb yview $args"
  eval ".edgat.io.box.port.lb yview $args"
  eval ".edgat.io.box.type.lb yview $args"
  eval ".edgat.io.box.sizesb.lbsb.lb yview $args"
}

proc edgatAddPort {i name port type size} {
  .edgat.io.box.name.lb insert $i $name
  .edgat.io.box.port.lb insert $i $port
  .edgat.io.box.type.lb insert $i $type
  .edgat.io.box.sizesb.lbsb.lb insert $i $size
}

proc edgatIOBoxReplace {i name port type size} {
  global edport_type

  if { $name == "" || $name == "*unnamed*" } { 
    set name "*unnamed*"
  } elseif { ![regexp {^[A-Za-z0-9_]*$} $name] } {
    errmsg "Illegal signal name '$name'.  Please correct."
    return 0
  }

  if { $edport_type == "Module" } {
    if { $port == "" || $port == "*unnamed*" || ![regexp {^[A-Za-z0-9_]*$} $port] } {
      errmsg "Illegal port name '$port' for block."
      return 0
    }
  } else {
    if { $port == "" || $port == "*unnamed*" } { 
      set port "*unnamed*"
    } elseif { ![regexp {^[A-Za-z_]+[0-9_]*(:[A-Za-z_][A-Za-z_0-9]*)?$} $port] } {
      errmsg "Illegal port name '$port'.  Please correct."
      return 0
    }
  }

  if { ![regexp {^-?[0-9]+$} $size] } {
    errmsg "Bit size '$size' is not a number.  Please correct."
    return 0
  }
  if { $size < 1 || $size > 32 } {
    errmsg "Bit size must be between 1 and 32.  Please correct."
    return 0
  }

  .edgat.io.box.name.lb delete $i
  .edgat.io.box.port.lb delete $i
  .edgat.io.box.type.lb delete $i
  .edgat.io.box.sizesb.lbsb.lb delete $i

  .edgat.io.box.name.lb insert $i $name
  .edgat.io.box.port.lb insert $i $port
  .edgat.io.box.type.lb insert $i $type
  .edgat.io.box.sizesb.lbsb.lb insert $i $size

  return 1
}


proc portEditOK {inGateEdit} {
  global edport_idx edport_sig edport_port edport_basePort edport_type edport_bits edport_ok

  if { $inGateEdit } {
    if { [edgatIOBoxReplace $edport_idx $edport_sig "$edport_basePort$edport_port" $edport_type $edport_bits] } {
      destroy .edport 
    }
  } {
    set edport_ok 1
    destroy .edport 
  }
}

########################################
#
# Throw up a dialog box for changing port values
#
proc edgatPortEdit {inGateEdit pos} {
  global edport_idx edport_sig edport_basePort edport_port edport_type edport_bits
  global edgat_type edgat_wops edport_ok

  if { $inGateEdit } {
    catch { set sel [selection own] }

    if { $sel != ".edgat.io.box.name.lb" && $sel != ".edgat.io.box.port.lb"
      && $sel != ".edgat.io.box.type.lb" && $sel != ".edgat.io.box.sizesb.lbsb.lb" } {

      errmsg "No port selected."
      return;
    }

    set edport_idx [$sel curselection] 
    set edport_sig  [.edgat.io.box.name.lb get $edport_idx]
    set edport_port [.edgat.io.box.port.lb get $edport_idx]
    set edport_type [.edgat.io.box.type.lb get $edport_idx]
    set edport_bits [.edgat.io.box.sizesb.lbsb.lb get $edport_idx]
  }

  set edport_ok 0
  set oldPort $edport_port

  set p [string first ":" $edport_port]
  if { $p > 0 } {
    set edport_basePort [string range $edport_port 0 $p]
    set edport_port [string range $edport_port [expr $p + 1] end]
    set isBlock 1
  } {
    set edport_basePort ""
    set isBlock 0
  }

  toplevel .edport

  wm resizable .edport 0 0
  wm title .edport "TKGate: Port Parameters"

  wm geometry .edport $pos

  frame .edport.box -relief raised -bd 2
  label .edport.box.siglab  -text "Signal Name:"
  label .edport.box.portlab -text "Port Name:"
  label .edport.box.iolab   -text "Type:"
  label .edport.box.bitlab  -text "Bit Width:"
  entry .edport.box.sig     -textvariable edport_sig
  entry .edport.box.port    -textvariable edport_port

  frame .edport.box.io
  radiobutton .edport.box.io.in -text in -variable edport_type -value in
  radiobutton .edport.box.io.out -text out -variable edport_type -value out
  radiobutton .edport.box.io.bdir -text inout -variable edport_type -value bidir
  pack .edport.box.io.in .edport.box.io.out .edport.box.io.bdir -side left

  entry .edport.box.bit     -textvariable edport_bits

  bind .edport.box.sig <KeyPress-Return> "portEditOK $inGateEdit"
  bind .edport.box.port <KeyPress-Return> "portEditOK $inGateEdit"
  bind .edport.box.bit <KeyPress-Return> "portEditOK $inGateEdit"

  if { !$isBlock && $inGateEdit } {
    .edport.box.io.in   configure -state disabled
    .edport.box.port    configure -state disabled
    .edport.box.io.out  configure -state disabled
    .edport.box.io.bdir configure -state disabled
  }

  grid .edport.box.siglab  -column 0 -row 0 -sticky e -padx 5 -pady 2
  grid .edport.box.sig     -column 1 -row 0 -sticky w -padx 5 -pady 2
  grid .edport.box.portlab -column 0 -row 1 -sticky e -padx 5 -pady 2
  grid .edport.box.port    -column 1 -row 1 -sticky w -padx 5 -pady 2
  grid .edport.box.iolab   -column 0 -row 2 -sticky e -padx 5 -pady 2
  grid .edport.box.io      -column 1 -row 2 -sticky w -padx 5 -pady 2
  grid .edport.box.bitlab  -column 0 -row 3 -sticky e -padx 5 -pady 2
  grid .edport.box.bit     -column 1 -row 3 -sticky w -padx 5 -pady 2

  frame  .edport.confirm -relief raised -bd 2
  button .edport.confirm.ok     -text OK -command "portEditOK $inGateEdit"
  button .edport.confirm.cancel -text Cancel -command { destroy .edport }
  pack .edport.confirm.ok -side left -padx 5 -pady 5
  pack .edport.confirm.cancel -side right -padx 5 -pady 5

  pack .edport.box .edport.confirm -fill both

  if { $edport_sig == "*unnamed*" } {
    .edport.box.sig selection range 0 end
    .edport.box.sig icursor end
    focus .edport.box.sig
  }

  helpon .edport.box.siglab  {The name of the selected signal on the
selected gate.  You can change the name
of the signal by editing it here.}
  helpon .edport.box.portlab {The name of the port for this signal
on the gate.  This field can only be
edited for module instances.}
  helpon .edport.box.iolab   {The direction of the selected signal
on the selected gate.  This field can only
be edited for module instances.}
  helpon .edport.box.bitlab  {The bit width of the selected signal
on the selected gate.  You can change the
bitwidth by editing it here.}

  if { !$inGateEdit } {
    .edport.box.port selection range 0 end
    focus .edport.box.port
  }


  grab set .edport
  tkwait window .edport
  grab release .edport

  if { $inGateEdit } {
    lappend edgat_wops [list edit $oldPort $edport_sig "$edport_basePort$edport_port" $edport_type $edport_bits ]
  }

  return $edport_ok
}

########################################
#
# Throw up a dialog box for a new signal, or issue
# an error if ports can not be added to the current
# gate.
#
proc edgatPortAdd {} {
  global edgat_wops

  set Q -1
  set X ""
  set B ""
  set N ""
  set T ""
  set L [.edgat.io.box.name.lb size]
  for {set i 0} {$i < $L} {incr i} {
    set P [.edgat.io.box.port.lb get $i]
    if {[regexp {^([A-Za-z]+)([0-9]+)$} $P X B N]} {
      set T [.edgat.io.box.type.lb get $i]
      set Q $i
    }
  }
  if { $Q < 0 } {
    errmsg "Can't add ports to gates of this type."
    return
  }
  set N [expr $N + 1]
  incr Q
  edgatAddPort $Q "*unnamed*" $B$N $T 1
  selection clear
  .edgat.io.box.name.lb selection set $Q

  lappend edgat_wops [list add $B]
  edgatPortEdit 1 [offsetgeometry .edgat 50 50 ]

}

########################################
#
# Throw up a dialog box to delete a port.  Issue an
# error if the port is undeletable.
#
proc edgatPortDelete {} {
  global edgat_wops

  catch { set sel [selection own] }

  if { $sel != ".edgat.io.box.name.lb" && $sel != ".edgat.io.box.port.lb"
    && $sel != ".edgat.io.box.type.lb" && $sel != ".edgat.io.box.sizesb.lbsb.lb" } {

    errmsg "No port selected."
    return;
  }
  set edport_idx [$sel curselection] 

  set port [.edgat.io.box.port.lb get $edport_idx]

  if {![regexp {^([A-Za-z]+)([0-9]+)$} $port X B N]} {
    errmsg "Selected port can not be deleted."
    return
  }

  set X [.edgat.io.box.port.lb get [expr $edport_idx + 1]]
  set Y ${B}1
  if { $N == 0 && $X != $Y } {
    errmsg "Selected port can not be deleted."
    return
  }

  selection clear

  .edgat.io.box.name.lb delete $edport_idx
  .edgat.io.box.port.lb delete $edport_idx
  .edgat.io.box.type.lb delete $edport_idx
  .edgat.io.box.sizesb.lbsb.lb delete $edport_idx

  set L [.edgat.io.box.port.lb size]
  set j 0
  for {set i 0} {$i < $L} {incr i} {
    set P [.edgat.io.box.port.lb get $i]
    if {[regexp {^([A-Za-z]+)([0-9]+)$} $P X Bj Nj]} {
      .edgat.io.box.port.lb delete $i
      .edgat.io.box.port.lb insert $i $Bj$j
      incr j
    }
  }

  lappend edgat_wops [list delete $port]
}

#################################################
#
# Select interval and total width from an omega value.
#
#     P		Power of ten >= to omega
#     Q		Normalized omega value
#     V         Size of interval
#
proc edgatChooseW {omega} {

  set omega [expr 1.2*$omega ]
  if { $omega < 10 } {set omega 10 }

  for {set P 1.0} {$P < $omega} {set P [expr $P * 10.0]} {}

  set Q [expr ($P - $omega)/$P ]

  if { $Q >= 0.8 } {
     set V $P*0.02
  } elseif { $Q >= 0.6 } {
     set V $P*0.05
  } else {
     set V $P*0.1
  }

  set W 0
  for {set I 0} { $W <= $omega } { incr I } {
    set W [expr int($I * $V) ]
  }
  set W [expr int($I * $V) ]

  return [list $I $W]
}

proc edgatClockFrame {w} {
  global ecpI ecpW

  $w.clock.wave delete frame
  set clkFrame [list]
  for {set i 0} {$i <= $ecpI } {incr i} {
    set x [expr 15 + ($i)*220.0/$ecpI ]
    $w.clock.wave create line ${x} 75 ${x} 85 -tag frame
    $w.clock.wave create text ${x} 100 -text [expr $i*$ecpW/$ecpI ] -anchor s -tag frame
  }
}

########################################
#
# Update clock display from value change
#
proc edgatSetClockTrace {w} {
  global ecpl1 ecpl2 ecpl3 ecpl4 ecpl5
  global ecpE0 ecpE1 ecpE2
  $w.clock.wave coords $ecpl1 $ecpE0  5 $ecpE0 75
  $w.clock.wave coords $ecpl2 15     65 $ecpE1 65
  $w.clock.wave coords $ecpl3 $ecpE1 65 $ecpE1 15
  $w.clock.wave coords $ecpl4 $ecpE1 15 $ecpE2 15
  $w.clock.wave coords $ecpl5 $ecpE2 15 $ecpE2 65
}

########################################
#
# Translate movement of a clock graph component to actual new positons
# and new parameter values.
#
#
proc edgatMoveClock {w x} {
  global ecpS ecpE0 ecpE1 ecpE2
  global ecpl1 ecpl2 ecpl3 ecpl4 ecpl5
  global ecpPhi ecpDuty ecpOmega ecpW

  trace vdelete ecpOmega w edgatClockPUpdate
  trace vdelete ecpPhi w edgatClockPUpdate
  trace vdelete ecpDuty w edgatClockPUpdate

  if { $ecpS == $ecpl1 } {
    set ecpE0 $x
    if { $ecpE0 < 15 }      { set ecpE0 15 }
    if { $ecpE0 >= $ecpE2 } { set ecpE0 $ecpE2 }
    set ecpPhi [expr 100*($ecpE0 - 15)/($ecpE2 - 15) ]
  } elseif { $ecpS == $ecpl3 } {
    set ecpE1 $x
    if { $ecpE1 <= 15 }     { set ecpE1 15 }
    if { $ecpE1 >= $ecpE2 } { set ecpE1 [expr $ecpE2 - 1] }
    set ecpDuty [expr 100*($ecpE1 - 15)/($ecpE2 - 15) ]
  } elseif { $ecpS == $ecpl5 } {
    set ecpE2 $x
    if { $ecpE2 <= $ecpE1 } { set ecpE2 [expr $ecpE1 + 1] }
    if { $ecpE2 <= $ecpE0 } { set ecpE2 [expr $ecpE0 + 1] }
    if { $ecpE2 >= 235 }    { set ecpE2 235 }
    set ecpE0 [expr 15 + int($ecpPhi*($ecpE2-15.0)/100.0)]
    set ecpE1 [expr 15 + int($ecpDuty*($ecpE2-15.0)/100.0)]
    set ecpOmega [expr $ecpW*($ecpE2 - 15)/220 ]
  }

  trace variable ecpOmega w edgatClockPUpdate
  trace variable ecpPhi w edgatClockPUpdate
  trace variable ecpDuty w edgatClockPUpdate

  edgatSetClockTrace $w
}


########################################
#
# Translate change in parameter values to change in graph
#
proc edgatClockPUpdate args {
  global ecpl1 ecpl2 ecpl3 ecpl4 ecpl5
  global ecpE0 ecpE1 ecpE2
  global ecpW ecpI ecpOmega ecpPhi ecpDuty

  if { [scan $ecpPhi "%d" P] != 1 } { set P 0 }
  if { [scan $ecpDuty "%d" D] != 1 } { set D 50 }
  if { [scan $ecpOmega "%d" O] != 1 } { set O $ecpW }

  set IW [edgatChooseW $ecpOmega]
  set ecpI [lindex $IW 0]
  set ecpW [lindex $IW 1]

  if { $P <= 0 } { set P 0 }
  if { $P >= 99 } { set P 99 }
  if { $D <= 0 } { set D 1 }
  if { $D >= 99 } { set D 99 }
  if { $O <= 0 } { set O 1 }

  set X [expr 220*$O/$ecpW ]

  set ecpE2 [expr 15 + $X ]
  set ecpE0 [expr 15 + $X*$P/100 ]
  set ecpE1 [expr 15 + $X*$D/100 ]

  edgatClockFrame .edgat
  edgatSetClockTrace .edgat
}

########################################
#
# Clock parameter edit window
#
proc  edgatClockParms {w omega phi duty} {
  global ecpS ecpl1 ecpl2 ecpl3 ecpl4 ecpl5
  global ecpE0 ecpE1 ecpE2
  global ecpW ecpI ecpOmega ecpPhi ecpDuty

  set IW [edgatChooseW $omega]
  set ecpI [lindex $IW 0]
  set ecpW [lindex $IW 1]

  set ecpOmega $omega
  set ecpPhi $phi
  set ecpDuty $duty

  frame $w.clock -relief raised -bd 2

  frame $w.clock.cycle
  label $w.clock.cycle.lab -text "Cycle Width: " -anchor e -width 12
  entry $w.clock.cycle.ent -width 6 -textvariable ecpOmega
  pack $w.clock.cycle.lab $w.clock.cycle.ent -side left -pady 2

  frame $w.clock.phase
  label $w.clock.phase.lab -text "Phase(%): " -anchor e -width 12
  entry $w.clock.phase.ent -width 6 -textvariable ecpPhi
  pack $w.clock.phase.lab $w.clock.phase.ent -side left -pady 2

  frame $w.clock.duty
  label $w.clock.duty.lab -text "Duty(%): " -anchor e -width 12
  entry $w.clock.duty.ent -width 6 -textvariable ecpDuty
  pack $w.clock.duty.lab $w.clock.duty.ent -side left -pady 2

  bind $w.clock.cycle.ent <KeyPress-Return> "edgatOK $w"
  bind $w.clock.phase.ent <KeyPress-Return> "edgatOK $w"
  bind $w.clock.duty.ent <KeyPress-Return> "edgatOK $w"

  canvas $w.clock.wave -width 250 -height 110 -closeenough 5.0
  $w.clock.wave create line 15 75 235 75
  edgatClockFrame $w

  set ecpl1 [$w.clock.wave create line 0 0 0 0 -tags edge ]
  set ecpl2 [$w.clock.wave create line 0 0 0 0 ]
  set ecpl3 [$w.clock.wave create line 0 0 0 0 -tags edge ]
  set ecpl4 [$w.clock.wave create line 0 0 0 0 ]
  set ecpl5 [$w.clock.wave create line 0 0 0 0 -tags edge ]

  edgatClockPUpdate

  $w.clock.wave bind edge <Button-1> {
	set ecpS [.edgat.clock.wave find withtag current]
  }
  $w.clock.wave bind edge <B1-Motion> "edgatMoveClock $w %x"

  pack $w.clock.wave 
  pack $w.clock.cycle $w.clock.phase $w.clock.duty -anchor w

  pack $w.clock -fill both

  helpon $w.clock.cycle.lab {The total number of epochs in a clock cycle.}
  helpon $w.clock.phase.lab {The starting point of the cycle (in percent).}
  helpon $w.clock.duty.lab {The percent of the cycle, the clock is low.}
}

proc edgatIO {w} {
  frame $w.io -relief raised -bd 2
  frame $w.io.box
  frame $w.io.but
  pack $w.io.box $w.io.but -padx 5 -pady 5

  frame $w.io.box.name
  frame $w.io.box.port
  frame $w.io.box.type
  frame $w.io.box.sizesb
  frame $w.io.box.sizesb.lbsb
  label $w.io.box.name.la -text "Signal Name"
  label $w.io.box.port.la -text "Port"
  label $w.io.box.type.la -text "Type"
  label $w.io.box.sizesb.la -text "Bits"
  listbox $w.io.box.name.lb -width 15 -height 5 -yscrollcommand "$w.io.box.sizesb.lbsb.vert set"
  listbox $w.io.box.port.lb -width 10 -height 5
  listbox $w.io.box.type.lb -width 5 -height 5
  listbox   $w.io.box.sizesb.lbsb.lb -width 5 -height 5
  scrollbar $w.io.box.sizesb.lbsb.vert -command "edgatPortView"
  pack $w.io.box.sizesb.lbsb.lb $w.io.box.sizesb.lbsb.vert -side left -fill y
  pack $w.io.box.name.la $w.io.box.name.lb -anchor w
  pack $w.io.box.port.la $w.io.box.port.lb -anchor w
  pack $w.io.box.type.la $w.io.box.type.lb -anchor w
  pack $w.io.box.sizesb.la $w.io.box.sizesb.lbsb -anchor w
  pack $w.io.box.name $w.io.box.port $w.io.box.type $w.io.box.sizesb -side left -fill both

  bind $w.io.box.name.lb <Double-ButtonRelease-1> "edgatPortEdit 1 [offsetgeometry .edgat 50 50 ]"
  bind $w.io.box.port.lb <Double-ButtonRelease-1> "edgatPortEdit 1 [offsetgeometry .edgat 50 50 ]"
  bind $w.io.box.type.lb <Double-ButtonRelease-1> "edgatPortEdit 1 [offsetgeometry .edgat 50 50 ]"
  bind $w.io.box.sizesb.lbsb.lb <Double-ButtonRelease-1> "edgatPortEdit 1 [offsetgeometry .edgat 50 50 ]"

  button $w.io.but.edit -text Edit... -command "edgatPortEdit 1 [offsetgeometry .edgat 50 50 ]"
  button $w.io.but.add -text Add... -command edgatPortAdd
  button $w.io.but.delete -text Delete -command edgatPortDelete
  pack $w.io.but.edit $w.io.but.add $w.io.but.delete -padx 5 -pady 5 -side left
  pack $w.io -fill both

  helpon $w.io.box.name.la "Name of connected net."
  helpon $w.io.box.port.la "Port to which net is connected."
  helpon $w.io.box.type.la "Type of connection."
  helpon $w.io.box.sizesb.la "Bit width of connected net."

  helpon $w.io.but.edit "Edit the selected port."
  helpon $w.io.but.add "Add a port."
  helpon $w.io.but.delete "Delete the selected port."
}

proc edgatBasic {w} {
  global edgat_type edgat_name edgat_hideName edgat_blockFunc

  frame $w.basic -relief raised -bd 2
  frame $w.basic.type
  frame $w.basic.name
  frame $w.basic.hide
  frame $w.basic.anchor

  label $w.basic.type.lab -text "Gate Type:" -width 12 -anchor e
  label $w.basic.type.ent -text "$edgat_type" -width 15 -anchor w
  pack $w.basic.type.lab $w.basic.type.ent -padx 5 -pady 5 -side left 

  label $w.basic.name.lab -text "Gate Name:" -width 12 -anchor e
  entry $w.basic.name.ent -width 15 -textvariable edgat_name
  pack $w.basic.name.lab $w.basic.name.ent -padx 5 -pady 5 -side left 

  label $w.basic.hide.lab -text "Hide Name:" -width 12 -anchor e
  checkbutton $w.basic.hide.ent -variable edgat_hideName
  pack $w.basic.hide.lab $w.basic.hide.ent -padx 5 -pady 5 -side left 

  label $w.basic.anchor.lab -text "Anchor:" -width 12 -anchor e
  checkbutton $w.basic.anchor.ent -variable edgat_anchor
  label $w.basic.anchor.xlab -text "X:"
  entry $w.basic.anchor.xent -width 4 -textvariable edgat_xpos
  label $w.basic.anchor.ylab -text "Y:"
  entry $w.basic.anchor.yent -width 4 -textvariable edgat_ypos
  pack $w.basic.anchor.lab $w.basic.anchor.ent $w.basic.anchor.xlab -padx 5 -pady 5 -side left 
  pack $w.basic.anchor.xent $w.basic.anchor.ylab $w.basic.anchor.yent -padx 5 -pady 5 -side left 

  pack $w.basic.type $w.basic.name $w.basic.hide $w.basic.anchor -anchor w

  bind $w.basic.name.ent <KeyPress-Return> "edgatOK $w"

  pack $w.basic -fill both -ipady 5

  helpon $w.basic.type.lab "Type of the gate."
  helpon $w.basic.name.lab "Name of this gate instance."
  helpon $w.basic.hide.lab "Set this flag to disable\ndisplay of gate name."
  helpon $w.basic.anchor.lab "Set this flag to anchor\nthe position of a gate."
  helpon $w.basic.anchor.xlab "X coordinate of gate."
  helpon $w.basic.anchor.ylab "Y coordinate of gate."
}

proc edgatSwitch {w} {
  global edgat_switch
  frame $w.switch -relief raised -bd 2
  checkbutton $w.switch.state -text "Button State" -variable edgat_switch
  pack $w.switch.state -padx 5 -pady 5 -anchor w
  pack $w.switch -fill both

  helpon $w.switch.state {The initial state of the switch to use when
starting a simulation.}
}

proc edgatDip {w} {
  global edgat_dip
  frame $w.dip -relief raised -bd 2
  label $w.dip.label -text "Switch Value:"
  entry $w.dip.state -textvariable edgat_dip
  pack $w.dip.label $w.dip.state -padx 5 -pady 5 -side left -anchor w
  pack $w.dip -fill both
  bind $w.dip.state <KeyPress-Return> "edgatOK $w"

  helpon $w.dip.label {The initial state of the dip switch to use
when starting a simulation.}
}

proc edgatTap {w} {
  global edgat_tap
  frame $w.tap -relief raised -bd 2
  label $w.tap.label -text "Bit Range:"
  entry $w.tap.state -textvariable edgat_tap
  pack $w.tap.label $w.tap.state -padx 5 -pady 5 -side left -anchor w
  pack $w.tap -fill both
  bind $w.tap.state <KeyPress-Return> "edgatOK $w"

  helpon $w.tap.label {The range of bits to pull off a bus.}
}

proc edgatMem {w} {
  global edgat_memFile
  frame $w.mem -relief raised -bd 2
  label $w.mem.label -text "Memory File:"
  entry $w.mem.file -textvariable edgat_memFile
  button $w.mem.browse -text "Browse..."  -command {
    global mem_filter mem_filetypes edgate_memFile
    set file [tk_getOpenFile -defaultextension $mem_filter -filetypes $mem_filetypes]
    if { $file != "" } { 
      set edgat_memFile $file
      .edgat.mem.file icursor end
      .edgat.mem.file xview end
    }
  }

  pack $w.mem.label $w.mem.file $w.mem.browse -padx 5 -pady 5 -side left -anchor w
  pack $w.mem -fill both
  bind $w.mem.file <KeyPress-Return> "edgatOK $w"

  helpon $w.mem.label {The file with the initial state for this memory.
This file is read when the simulator is started.}
}

proc edgatModule {w} {
  global edgat_newBlock

  frame $w.mod -relief raised -bd 2
  label $w.mod.lab -text "Function:" -width 12 -anchor e
  entry $w.mod.ent -width 15 -textvariable edgat_blockFunc
  bind $w.mod.ent <KeyPress-Return> "edgatOK $w"
  pack $w.mod.lab $w.mod.ent -padx 5 -pady 5 -side left 
  pack $w.mod -anchor w
  if { $edgat_newBlock } {
    $w.mod.ent selection range 0 end
    focus $w.mod.ent
  }
  helpon $w.mod.lab "The function type\nof this module."
  pack $w.mod -fill both
}

proc edgatFrame {w} {
  global edgat_newBlock

  frame $w.frm -relief raised -bd 2
  label $w.frm.lab -text "Label:" -anchor e
  entry $w.frm.ent -width 30 -textvariable edgat_commentLines(0)
  bind $w.frm.ent <KeyPress-Return> "edgatOK $w"
  pack $w.frm.lab $w.frm.ent -padx 5 -pady 5 -side left 
  pack $w.frm -anchor w
  if { $edgat_newBlock } {
    $w.frm.ent selection range 0 end
    focus $w.frm.ent
  }
  helpon $w.frm.lab "The frame label."
  pack $w.frm -fill both
}

proc edgatOK {w} { global edgat_ok; set edgat_ok 1; destroy $w }

proc edgatConfirm {w} {
  global edgat_ok
  frame $w.confirm -relief raised -bd 2
  button $w.confirm.ok -text OK -command " edgatOK $w"
  button $w.confirm.cancel -text Cancel -command "set edgat_ok 0; destroy $w"
  pack $w.confirm.ok -side left -padx 5 -pady 5
  pack $w.confirm.cancel -side right -padx 5 -pady 5
  pack $w.confirm -fill both
}

proc tkg_saveComment {w} {
  global edgat_commentLen edgat_commentLines edgat_ok

  for { set i 1 } { [$w.f.t compare $i.end < end] } { incr i } {
    set x [$w.f.t get $i.0 $i.end]
    set j [expr $i - 1]
    set edgat_commentLines($j) $x
  }
  set edgat_commentLen [expr $i - 1]
  set edgat_ok 1
}

#
# Dialog for editing comments
#
proc tkg_editCommentGate {} {
  global edgat_geom edgat_commentLen edgat_commentLines

  set w .edgat
  toplevel $w
  wm title $w "TKGate: Comment Text"
  wm geometry $w $edgat_geom

  frame $w.f -relief raised -bd 2
  text $w.f.t -yscrollcommand "$w.f.vb set" -xscrollcommand "$w.f.hb set" -width 45 -height 15
  scrollbar $w.f.vb -command "$w.f.t yview"
  scrollbar $w.f.hb -command "$w.f.t xview" -orient horizontal

  grid rowconfig $w.f 0 -weight 1 -minsize 0
  grid columnconfig $w.f 0 -weight 1 -minsize 0

  grid $w.f.t -row 0 -column 0 -sticky news
  grid $w.f.vb -row 0 -column 1 -sticky news
  grid $w.f.hb -row 1 -column 0 -sticky news
  pack $w.f -ipadx 5 -ipady 5 -fill both -expand 1

  for {set i 0 } { $i < $edgat_commentLen } { incr i } {
    if { $i > 0 } { $w.f.t insert end "\n" }
    $w.f.t insert end $edgat_commentLines($i)
  }

  okcancel $w.ok "tkg_saveComment $w; destroy $w" "destroy $w"
  pack $w.ok -fill both

  focus $w.f.t

  grab set $w
  tkwait window $w
  grab release $w
}

#
# Dialog for editing gate properties
#
proc tkg_editGate {} {
  global edgat_type edgat_name edgat_hideName edgat_geom edgat_wires edgat_wops
  global ecpOmega ecpPhi ecpDuty

  if { $edgat_type == "COMMENT" } {
    tkg_editCommentGate
    return;
  }

  set edgat_wops {}

  set w .edgat
  if { [catch { toplevel $w }] } { return }
  wm resizable $w 0 0
  wm title $w "TKGate: Gate Parameters"
  wm geometry $w $edgat_geom

  edgatBasic $w
  edgatIO $w
  if { $edgat_type == "Clock" } { edgatClockParms $w $ecpOmega $ecpPhi $ecpDuty }
  if { $edgat_type == "Switch" } { edgatSwitch $w }
  if { $edgat_type == "DIP" } { edgatDip $w }
  if { $edgat_type == "Tran" } { edgatTap $w }
  if { $edgat_type == "RAM" } { edgatMem $w }
  if { $edgat_type == "ROM" } { edgatMem $w }
  if { $edgat_type == "Module" } { edgatModule $w }
  if { $edgat_type == "Frame" } { edgatFrame $w }
  edgatConfirm $w

  foreach p $edgat_wires {
    eval "edgatAddPort end $p"
  }
  trace variable ecpOmega w edgatClockPUpdate
  trace variable ecpPhi w edgatClockPUpdate
  trace variable ecpDuty w edgatClockPUpdate

  grab set $w
  tkwait window $w
  grab release $w

  trace vdelete ecpOmega w edgatClockPUpdate
  trace vdelete ecpPhi w edgatClockPUpdate
  trace vdelete ecpDuty w edgatClockPUpdate
}

proc tkg_findObject {} {
  global find_type find_target simOn

  if { $simOn } {
    errmsg "'Find' not supported in simulation mode."
    return
  }

  set w .finder

  if { [catch { toplevel $w }] } {
    gat_find $find_type $find_target
    return
  }
 
  wm resizable $w 0 0
  wm title $w "TKGate: Find Object"
  wm geometry $w [offsetgeometry . 50 50 ]

  frame $w.t -relief raised -bd 2
  label $w.t.l -text "Find:"
  entry $w.t.e -textvariable find_target
  pack $w.t.l $w.t.e -side left -padx 5 -pady 5

  frame $w.rb -relief raised -bd 2
  radiobutton $w.rb.wandg -text "Search for wires only" -variable find_type -value 1
  radiobutton $w.rb.gonly -text "Search for gates only" -variable find_type -value 2
  radiobutton $w.rb.wonly -text "Search for wires and gates" -variable find_type -value 3
  pack $w.rb.wandg $w.rb.gonly $w.rb.wonly -pady 2 -anchor w


  frame $w.ok -relief raised -bd 2
  button $w.ok.find -text Find -command { gat_find $find_type $find_target }
  button $w.ok.clear -text Clear -command { set find_target ""; }
  button $w.ok.close -text Close -command { destroy .finder  }
  frame $w.ok.pad1
  frame $w.ok.pad2
  pack $w.ok.find -side left -pady 5 -padx 5 -fill x
  pack $w.ok.pad1 -side left -pady 5 -padx 5 -fill x -expand 1
  pack $w.ok.clear -side left -pady 5 -padx 5 -fill x
  pack $w.ok.pad2 -side left -pady 5 -padx 5 -fill x -expand 1
  pack $w.ok.close -side left -pady 5 -padx 5 -fill x

  bind $w <KeyPress-Return> { .finder.ok.find invoke }

  pack $w.t $w.rb $w.ok -fill both -ipadx 5 -ipady 5

  $w.t.e selection range 0 end
  focus $w.t.e
}
