#   Copyright (C) 1987-1999 by Jeffery P. Hansen
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Last edit by hansen on Thu May  6 16:04:13 1999
#
#
set opts_mode 0
set opts_regionUpdate 0
set opts_siteName ""
set opts_blockMoveStyle 0
set opts_helpBalloons 1
set opts_noviceMode 1
set opts_allowDebug 1
set opts_checkpointEnabled 1
set opts_checkpointFreq 300

set sopts_simStepSize $tkg_simStepSize
set sopts_simClockStepSize $tkg_simClockStepSize
set sopts_simClockOverStep $tkg_simClockOverStep
set sopts_allowDebug $tkg_allowDebug
set sopts_simActClock $tkg_simActClock
set sopts_simUseActClock $tkg_simUseActClock
set sopts_simInitScript $tkg_simInitScript
set sopts_simLogFile ""
set sopts_simDelayFile ""
set sopts_simCustomDelay 0

proc tkg_saveOptions {} {
  global tkg_prefFile tkg_enableBeakModes
  global tkg_trekMode tkg_batMode tkg_baderMode tkg_batRate
  global tkg_siteName tkg_regionUpdate
  global tkg_allowDebug tkg_blockMoveStyle tkg_helpBalloons tkg_noviceMode
  global tkg_printCommand tkg_printPgSize tkg_printPgOrient
  global tkg_printDuplex tkg_printStyle tkg_printIndex tkg_printGraph
  global tkg_checkpointFreq tkg_checkpointEnabled
  global tkg_simStepSize tkg_simClockStepSize tkg_simClockOverStep
  global tkg_simActClock tkg_simUseActClock tkg_simDebugInterface
  global tkg_simInitScript tkg_simCustomDelay tkg_simDelayFile

  set fd [open $tkg_prefFile w]
  puts $fd "#"
  puts $fd "# Automatically generated preferences file - DO NOT EDIT"
  puts $fd "#"
  puts $fd ""

  puts $fd "#"
  puts $fd "# Basic settings"
  puts $fd "#"
  puts $fd "set tkg_siteName \"$tkg_siteName\""
  puts $fd "set tkg_regionUpdate $tkg_regionUpdate"
  puts $fd "set tkg_blockMoveStyle $tkg_blockMoveStyle"
  puts $fd "set tkg_helpBalloons $tkg_helpBalloons"
  puts $fd "set tkg_noviceMode $tkg_noviceMode"
  puts $fd ""
   
  puts $fd "#"
  puts $fd "# Mode settings"
  puts $fd "#"
  puts $fd "set tkg_enableBeakModes $tkg_enableBeakModes"
  puts $fd "set tkg_baderMode $tkg_baderMode"
  puts $fd "set tkg_batMode $tkg_batMode"
  puts $fd "set tkg_trekMode $tkg_trekMode"
  puts $fd "set tkg_batRate $tkg_batRate"
  puts $fd "set tkg_allowDebug $tkg_allowDebug"
  puts $fd ""


  puts $fd "#"
  puts $fd "# Simulator settings"
  puts $fd "#"
  puts $fd "set tkg_simStepSize $tkg_simStepSize"
  puts $fd "set tkg_simClockStepSize $tkg_simClockStepSize"
  puts $fd "set tkg_simClockOverStep $tkg_simClockOverStep"
  puts $fd "set tkg_simDebugInterface $tkg_simDebugInterface"
  puts $fd "set tkg_simActClock \"$tkg_simActClock\""
  puts $fd "set tkg_simUseActClock $tkg_simUseActClock"
  puts $fd "set tkg_simInitScript \"$tkg_simInitScript\""
  puts $fd "set tkg_simCustomDelay $tkg_simCustomDelay"
  puts $fd "set tkg_simDelayFile \"$tkg_simDelayFile\""
  puts $fd ""

  puts $fd "#"
  puts $fd "# Pinter settings"
  puts $fd "#"
  puts $fd "set tkg_printCommand \"$tkg_printCommand\""
  puts $fd "set tkg_printPgSize $tkg_printPgSize"
  puts $fd "set tkg_printPgOrient $tkg_printPgOrient"
  puts $fd "set tkg_printDuplex $tkg_printDuplex"
  puts $fd "set tkg_printStyle $tkg_printStyle"
  puts $fd "set tkg_printIndex $tkg_printIndex"
  puts $fd "set tkg_printGraph $tkg_printGraph"
  puts $fd ""

  puts $fd "#"
  puts $fd "# Checkpointing"
  puts $fd "#"
  puts $fd "set tkg_checkpointEnabled $tkg_checkpointEnabled"
  puts $fd "set tkg_checkpointFreq $tkg_checkpointFreq"

  close $fd
}

proc tkg_optsGet {} {
  global opts_mode tkg_trekMode tkg_batMode tkg_baderMode

  copyVar opts_siteName tkg_siteName
  copyVar opts_regionUpdate tkg_regionUpdate
  copyVar opts_blockMoveStyle tkg_blockMoveStyle
  copyVar opts_helpBalloons tkg_helpBalloons
  copyVar opts_noviceMode tkg_noviceMode
  copyVar opts_allowDebug tkg_allowDebug
  copyVar opts_checkpointEnabled tkg_checkpointEnabled
  copyVar opts_checkpointFreq tkg_checkpointFreq

  copyVar sopts_simStepSize tkg_simStepSize
  copyVar sopts_simClockStepSize tkg_simClockStepSize
  copyVar sopts_simClockOverStep tkg_simClockOverStep
  copyVar sopts_simDebugInterface tkg_simDebugInterface
  copyVar sopts_simActClock tkg_simActClock
  copyVar sopts_simUseActClock tkg_simUseActClock
  copyVar sopts_simInitScript tkg_simInitScript
  copyVar sopts_simCustomDelay tkg_simCustomDelay
  copyVar sopts_simDelayFile tkg_simDelayFile

  copyVar pd_print tkg_printCommand
  copyVar pd_paper tkg_printPgSize
  copyVar pd_orient tkg_printPgOrient
  copyVar pd_duplexMode tkg_printDuplex
  copyVar pd_style tkg_printStyle
  copyVar pd_index tkg_printIndex
  copyVar pd_graph tkg_printGraph

  if { $tkg_baderMode != 0 } {
    set opts_mode 3
  } elseif { $tkg_trekMode != 0 } {
    set opts_mode 2
  } elseif { $tkg_batMode != 0 } {
    set opts_mode 1
  } else {
    set opts_mode 0
  }
}

proc tkg_optsStore {} {
  global opts_mode opts_siteName
  global tkg_trekMode tkg_batMode tkg_baderMode tkg_batRate
  global tkg_siteName 

  set tkg_siteName [tr-d [string trim $opts_siteName " \t"] "\""]
  copyVar tkg_regionUpdate opts_regionUpdate
  copyVar tkg_blockMoveStyle opts_blockMoveStyle
  copyVar tkg_helpBalloons opts_helpBalloons
  copyVar tkg_noviceMode opts_noviceMode
  copyVar tkg_allowDebug opts_allowDebug
  copyVar tkg_checkpointEnabled opts_checkpointEnabled
  checkCopyVar tkg_checkpointFreq opts_checkpointFreq 1 9999

  checkCopyVar tkg_simStepSize sopts_simStepSize		1 1000000
  checkCopyVar tkg_simClockStepSize sopts_simClockStepSize	1 1000000
  checkCopyVar tkg_simClockOverStep sopts_simClockOverStep	0 1000000
  copyVar tkg_simDebugInterface sopts_simDebugInterface	
  copyVar tkg_simActClock sopts_simActClock
  copyVar tkg_simUseActClock sopts_simUseActClock
  copyVar tkg_simInitScript sopts_simInitScript
  copyVar tkg_simCustomDelay sopts_simCustomDelay
  copyVar tkg_simDelayFile sopts_simDelayFile

  copyVar tkg_printCommand pd_print
  copyVar tkg_printPgSize pd_paper
  copyVar tkg_printPgOrient pd_orient
  copyVar tkg_printDuplex pd_duplexMode
  copyVar tkg_printStyle pd_style
  copyVar tkg_printIndex pd_index
  copyVar tkg_printGraph pd_graph

  set tkg_trekMode 0
  set tkg_batMode 0
  set tkg_baderMode 0
  switch $opts_mode {
    1 { set tkg_batMode 1; after $tkg_batRate gat_batInc }
    2 { set tkg_trekMode 1 }
    3 { set tkg_baderMode 1 }
    default { }
  }

  tkg_saveOptions
}

proc tkg_eoBasic {w} {
  frame $w -relief raised -bd 2
  label $w.siteL -text "Site Name:" -anchor w
  entry $w.siteE -width 30 -textvariable opts_siteName

  grid $w.siteL -row 0 -column 0 -sticky e -padx 3 -pady 2
  grid $w.siteE -row 0 -column 1 -sticky w -padx 3 -pady 2

  helpon $w.siteL {The name of the site where tkgate is
installed.  This name will be used on
any printer or postscript output.}
}

proc tkg_eoDisplay {w} {
  frame $w -relief raised -bd 2
  frame $w.f
  checkbutton $w.f.ru -variable opts_regionUpdate -text "Region Update"
  checkbutton $w.f.om -variable opts_blockMoveStyle -text "Outline Move modules"
  checkbutton $w.f.hb -variable opts_helpBalloons -text "Enable Help Balloons"
  checkbutton $w.f.db -variable opts_allowDebug -text "Enable Debugging"
  checkbutton $w.f.nv -variable opts_noviceMode -text "Novice Mode"
  frame $w.f.cpe

  checkbutton $w.f.cpe.b -variable opts_checkpointEnabled -text "Do Checkpointing"
  label $w.f.cpe.l -text "   Frequency:"
  entry $w.f.cpe.e -textvariable opts_checkpointFreq -width 4
  pack $w.f.cpe.b $w.f.cpe.l $w.f.cpe.e -side left

  pack $w.f.ru -anchor w
  pack $w.f.om -anchor w
  pack $w.f.hb -anchor w
  pack $w.f.db -anchor w
  pack $w.f.nv -anchor w
  pack $w.f.cpe -anchor w
  pack $w.f -padx 10 -pady 10 -anchor w

  helpon $w.f.ru {If this option is enabled, clipping will be
used to update only the exposed portion of
the window on a redisplay.  Otherwise the
entire display will be redrawn for all
exposures}

  helpon $w.f.om {If this option is enabled, only an outline
of module instances being moved will be displayed
while dragging.  Use this feature only on machines
with slow displays.}

  helpon $w.f.hb {If this option is enabled,  help balloons will 
be activated.  Help balloons, such as this one,
provide tips on interface elements when the
mouse is over them.}

  helpon $w.f.nv {If no other circuit is specified on the command
line.  A TkGate tutorial will be disaplyed as
the initial circuit on start up.}

  helpon $w.f.db {Enables several debugging features.  This
only useful to TkGate developers.}

  helpon $w.f.cpe.b {Enable checkpointing of unsaved circuits.}
  helpon $w.f.cpe.l {Frequency of checkpoints in seconds.}

}

proc tkg_eoModes {w} {
    frame $w -relief raised -bd 2
    checkbutton $w.enable -text "Enable Beak Modes" -variable tkg_enableBeakModes
    frame $w.f
    label $w.f.lab -text Mode:
    radiobutton $w.f.normal -text Normal -variable opts_mode -value 0
    radiobutton $w.f.bat -text Bat -variable opts_mode -value 1
    radiobutton $w.f.trek -text "Star Trek" -variable opts_mode -value 2
    radiobutton $w.f.miles -text "Miles" -variable opts_mode -value 3

    grid $w.f.lab -row 0 -column 0 -sticky e
    grid $w.f.normal -row 0 -column 1 -sticky w
    grid $w.f.bat -row 1 -column 1 -sticky w
    grid $w.f.trek -row 2 -column 1 -sticky w
    grid $w.f.miles -row 3 -column 1 -sticky w

    pack $w.enable -padx 5 -pady 5 -anchor w
    pack $w.f -padx 5 -pady 5 -anchor w

    helpon $w.enable {Enable these totally useless features.
If you disable this feature, these modes
(and this checkbox) will no longer appear
in the options box.  The only way to
reenable them will be to edit
you .tkgate-properties file.}

    helpon $w.f.miles {If this mode is enable, TkGate will
periodically insult the intelligence of
the user.}
    helpon $w.f.bat {If this mode is enable, TkGate will
set up an enviornment for designing a
bat computer.}
    helpon $w.f.trek {Beam me up Scoty!}
    helpon $w.f.normal {Disable fun stuff.}

}

#############################################################################
#
# simulator options
#

proc tkg_eoDebugOpts {w} {
  frame $w -relief groove -bd 2

  checkbutton $w.dbg -variable sopts_simDebugInterface -text "Display Simulator Stream" -anchor w

  frame $w.i
  label $w.i.logl -text "Log File:" -anchor w
  entry $w.i.loge -width 40 -textvariable sopts_simLogFile

  pack $w.dbg  -padx 5 -pady 5 -fill x -anchor w

  pack $w.i -padx 5 -pady 5
  pack $w.i.logl -anchor w
  pack $w.i.loge -anchor w
}

proc tkg_eoSimBaseOpts {w} {
  frame $w -relief groove -bd 2

  frame $w.t

  label $w.t.simstepL -text "Epoch Step Size:"
  entry $w.t.simstepE -width 5 -textvariable sopts_simStepSize

  label $w.t.clkstepL -text "Clock Cycle Step Size:"
  entry $w.t.clkstepE -width 5 -textvariable sopts_simClockStepSize

  label $w.t.clkostepL -text "Clock Overstep:"
  entry $w.t.clkostepE -width 5 -textvariable sopts_simClockOverStep

  frame $w.i
  label $w.i.initL -text "Initialization script:"
  entry $w.i.initE -width 40 -textvariable sopts_simInitScript

  grid $w.t.simstepL -row 0 -column 0 -sticky e -padx 3 -pady 5
  grid $w.t.simstepE -row 0 -column 1 -sticky w -padx 3 -pady 5
  grid $w.t.clkstepL -row 1 -column 0 -sticky e -padx 3 -pady 5
  grid $w.t.clkstepE -row 1 -column 1 -sticky w -padx 3 -pady 5 
  grid $w.t.clkostepL -row 2 -column 0 -sticky e -padx 3 -pady 5
  grid $w.t.clkostepE -row 2 -column 1 -sticky w -padx 3 -pady 5 

  pack $w.t
  pack $w.i -padx 5 -pady 5
  pack $w.i.initL -anchor w
  pack $w.i.initE -anchor w

  helpon $w.t.simstepL {The number of epochs to advance when
the step command is issued.}
  helpon $w.t.clkstepL {The number of clock cycles to advance
when the clock step command is issued.}
  helpon $w.t.clkostepL {The number of epochs past rising edge
of the clock to advance when the clock
step command is issued.}
  helpon $w.i.initL {A simulation script file to execute
automatically when the simulation
is started.}
}

proc tkg_eoSimClock {w} {
  global sopts_simUseActClock
  frame $w -relief groove -bd 2

  radiobutton $w.all -text "Clock step stops on all clock posedges" -variable sopts_simUseActClock -value 0 -command "$w.actNam configure -state disabled -foreground gray"
  radiobutton $w.act -text "Clock step stops on clock:" -variable sopts_simUseActClock -value 1 -command "$w.actNam configure -state normal -foreground black"
  entry $w.actNam -width 15 -textvariable sopts_simActClock

  if { $sopts_simUseActClock == 0 } {
    $w.actNam configure -state disabled
  }

  helpon $w.all {If this mode is enabled, the clock step
command will pause the simulation on the
positive edge of any clock in the circuit.}

  helpon $w.act {If this mode is enabled, the clock step
command will pause the simulation only on
the positive edge of the specified clock.}

  pack $w.all -padx 5 -pady 5 -anchor w
  pack $w.act $w.actNam -side left -padx 5 -pady 5 -anchor w
}

proc tkg_eoSimDelay {w} {
  frame $w -relief groove -bd 2

  checkbutton $w.l -text "Use Custom Delay Specification File" -anchor w -variable sopts_simCustomDelay
  entry $w.e -textvariable sopts_simDelayFile
  pack $w.l $w.e -padx 5 -pady 3 -fill both -anchor w
}


proc tkg_editOptions {} {
  global tkg_enableBeakModes tkg_allowDebug
  tkg_optsGet

  set w .opts
  if { [catch {toplevel $w}] } { return }

  wm resizable $w 0 0
  wm title $w "TkGate: Options"
  wm geometry $w [offsetgeometry . 50 50]

  frame $w.l
  frame $w.r

  tkg_eoBasic $w.l.basic
  pack $w.l.basic -fill both -ipadx 10 -ipady 10

#
# Mode portion of box
#
  if { $tkg_enableBeakModes } {
    tkg_eoModes $w.l.modes
    pack $w.l.modes -fill x
  }

  tkg_eoDisplay $w.r.display
  pack $w.r.display -fill x

  frame $w.r.sim -relief raised -bd 2
  label $w.r.sim.t -text "Simulator Options:" -anchor w
  pack $w.r.sim.t -fill x -padx 5 -pady 3

  tkg_eoSimBaseOpts $w.r.sim.base
  pack $w.r.sim.base -fill x -padx 5 -pady 3

  tkg_eoSimClock $w.r.sim.clock
  pack $w.r.sim.clock -fill x  -padx 5 -pady 3

  tkg_eoSimDelay $w.r.sim.delay
  pack $w.r.sim.delay -fill x  -padx 5 -pady 3

  if { $tkg_allowDebug } {
    tkg_eoDebugOpts $w.r.sim.opts
    pack $w.r.sim.opts -fill x  -padx 5 -pady 3
  }
  pack $w.r.sim -fill both -expand 1

#
# Printer options
#
  frame $w.l.print -relief raised -bd 2
  frame $w.l.print.f
  label $w.l.print.t -text "Print Options:" -anchor w
  pack $w.l.print.t $w.l.print.f -fill x -padx 5 -pady 5

  tkg_prntLprSel $w.l.print.f.lpr groove
  tkg_prntPaperSel $w.l.print.f.pap groove
  tkg_prntStyleSel $w.l.print.f.sty groove
  pack $w.l.print.f.lpr -fill x -pady 3
  pack $w.l.print.f.pap -fill x -pady 3
  pack $w.l.print.f.sty -fill x -pady 3
  pack $w.l.print -ipadx 10 -ipady 10 -fill both -expand 1

  okcancel $w.b { tkg_optsStore; destroy .opts } { destroy .opts }

  pack $w.b -fill x -side bottom
  pack $w.l -side left -fill both -expand 1
  pack $w.r -side right -fill both -expand 1

  bind $w <Return> { tkg_optsStore; destroy .opts }
}
