#   Copyright (C) 1987-1999 by Jeffery P. Hansen
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Last edit by hansen on Wed Mar 22 13:01:31 2000
#
#

set tkg_progName TKGate 

######################################################################
#
# Set the current directory
#

set cwd [pwd]/

######################################################################
#
# Initial size of main canvas
#
set tkg_initalWidth 830
set tkg_initalHeight 590

######################################################################
#
# Executable for simulator
#
set simExec "${tkg_gateHome}/libexec/gsim"

set tkg_simCustomDelay 0
set tkg_simDefaultDelayFile "${tkg_gateHome}/gsim.delay"
set tkg_simDelayFile ""

set tkg_simStepSize 1
set tkg_simClockStepSize 1
set tkg_simClockOverStep 21
set tkg_simDebugInterface 0
set tkg_simActClock ""
set tkg_simUseActClock 0
set tkg_simInitScript ""

######################################################################
#
# Status bar and file variables
#
set tkg_currentFile	""
set tkg_displayFile	""
set tkg_modifiedFlag	0
set tkg_currentBlock	"main"
set tkg_statusMessage	""
set tkg_doBackupOnSave	1
set tkg_wantCheckpoint	0
set tkg_checkpointFreq	300
set tkg_checkpointEnabled 0

######################################################################
#
# Display modes
#
set tkg_regionUpdate 1
set tkg_blockMoveStyle 0
set tkg_helpBalloons 1
set tkg_noviceMode 1

######################################################################
#
# Current mode and rotation
#
set mode 1
set rot 0

######################################################################
#
# Current circuit options
#
set tkg_discardChanges 0

######################################################################
#
# Print options
#
set tkg_printCommand "lpr"
set tkg_printPgSize 0
set tkg_printPgOrient landscape
set tkg_printDuplex 0
set tkg_printStyle fit
set tkg_printIndex 0
set tkg_printGraph 0



######################################################################
#
# Special modes
#
set tkg_enableBeakModes 0
set tkg_baderMode 0
set tkg_trekMode 0
set tkg_batMode 0
set tkg_batRate 200
set tkg_allowDebug 0

######################################################################
#
# Fonts
#
set body_font		"-adobe-courier-medium-r-normal-*-120-*"
set smallBody_font	"-adobe-courier-medium-r-normal-*-100-*"
set boldBody_font	"-adobe-courier-bold-r-normal-*-120-*"
set boldSmallBody_font	"-adobe-courier-bold-r-normal-*-100-*"
set msg_font		"-adobe-times-medium-r-normal-*-180-*"

set tkg_siteName	"Earth"
catch {
    set f [open ${tkg_gateHome}/sitename.txt r]
    set tkg_siteName [gets $f]
    close $f
}

set gf_file		""
set gf_result		""
set gf_filter		".v"
set gf_filetypes {
    {{Verilog Netlist}	{.v}	}
    {{All Files}	*	}
}
set gf_vfiletypes {
    {{Verilog Netlist}	{.v}	}
    {{All Files}	*	}
}

set simScript_filter	".gss"
set simScript_filetypes {
    {{Gate Simulation Script Files}	{.gss}	}
    {{All Files}			*	}
}

set mem_filter				".mem"
set mem_filetypes {
    {{Gate Memory Image Files}		{.mem}	}
    {{All Files}			*	}
}


######################################################################
#
# Preferences options.
#

set tkg_prefFile	"~/.tkgate-preferences"

if {[file exists $tkg_prefFile]} {
  source $tkg_prefFile
}

if {[file exists "~/.tkgaterc"]} {
  source "~/.tkgaterc"
}
