#   Copyright (C) 1987-1999 by Jeffery P. Hansen
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Last edit by hansen on Tue May  4 09:58:42 1999
#

proc tkg_scopeMenu {w} {
  menubutton $w.file -text File -menu $w.file.menu -underline 0
  menu $w.file.menu
  $w.file.menu add command -label "Print Trace..." -underline 0 -accelerator "Ctl-S p" -command tkg_scopePrintDlg
  $w.file.menu add command -label "Close" -underline 0 -accelerator "Ctl-S e" -command gat_endSimulate

  menubutton $w.simulate -text Simulate -menu $w.simulate.menu -underline 0
  tkg_makeSimMenu $w.simulate.menu normal

  $w.simulate.menu entryconfigure 1 -label "End Simulation" -underline 0 -command gat_endSimulate -accelerator "Ctl-S e"

  menubutton $w.trace -text Trace -menu $w.trace.menu -underline 0
  menu $w.trace.menu
  $w.trace.menu add command -label "Zoom In" -underline 5 -accelerator "<" -command { .scope.main.frame.canvas zoom -1 }
  $w.trace.menu add command -label "Zoom Out" -underline 5 -accelerator ">"  -command { .scope.main.frame.canvas zoom 1 }

  menubutton $w.help -text Help

  pack $w.file -side left
  pack $w.simulate -side left
  pack $w.trace -side left
  pack $w.help -side right 

  tk_menuBar $w $w.file $w.simulate \
	  $w.trace $w.help
}

proc tkg_makeScope {} {
  toplevel .scope
  wm geometry .scope +70+0

  frame .scope.mbar -relief raised -bd 2
  frame .scope.main
  frame .scope.main.frame -relief sunken -bd 2

  tkg_scopeMenu .scope.mbar

  gat_scope .scope.main.frame.canvas -width 500 -height 400
  scrollbar .scope.main.vert -command ".scope.main.frame.canvas yview"
  scrollbar .scope.main.horz -orient horizontal  -command ".scope.main.frame.canvas xview"
  pack .scope.main.vert -side right -fill y
  pack .scope.main.horz -side bottom -fill x
  pack .scope.main.frame -side top -fill both -expand 1 -padx 5 -pady 5
  pack .scope.main.frame.canvas -fill both -expand 1

  pack .scope.mbar -fill x
  pack .scope.main -fill both -expand 1
  tkg_setBindings .scope

  bind .scope <greater>		{ .scope.main.frame.canvas zoom 1 }
  bind .scope <less>		{ .scope.main.frame.canvas zoom -1 }
}

proc tkg_destroyScope {} {
  catch { destroy .scope }

}

proc scope_test {} {
  button .make -text Scope -command makeScope
  button .print -text Print -command printDlg
  pack .make .print -fill x
  wm geometry . +0+0
}
