#   Copyright (C) 1987-1999 by Jeffery P. Hansen
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Last edit by hansen on Mon May 17 11:18:17 1999
#

set runlogo_state -1
set runlogo_speed 100

proc tkg_setDisplayFile {n} {
  global tkg_displayFile

  set p [string last "/" $n]
  if { $p >= 0 } {
    set n [string range $n [expr $p + 1] end]
  }

  set tkg_displayFile $n
}

proc updateStatus args {
  global tkg_displayFile tkg_currentBlock tkg_modifiedFlag tkg_statusMessage

  if { $tkg_modifiedFlag } {
     set mod "*"
  } else {
     set mod ""
  }
  
  .status.file configure -text "File: $tkg_displayFile$mod"
  .status.block configure -text "Module: $tkg_currentBlock"
  .status.msg configure -text "$tkg_statusMessage" -anchor w
}

proc tkg_stopLogo {} {
  global bd runlogo_state
   .status.logo configure -bitmap "@$bd/rungate1.xbm"
  set runlogo_state -1
}

proc rkg_stepRunLogo {} {
  global bd runlogo_state runlogo_speed

  if { $runlogo_state > 0 } {
     .status.logo configure -bitmap "@$bd/rungate${runlogo_state}.xbm"
     set runlogo_state [expr $runlogo_state + 1 ]
     if { $runlogo_state > 14 } {
       set runlogo_state 1
     }
     after $runlogo_speed rkg_stepRunLogo
   }
}

proc tkg_runLogo {} {
  global bd runlogo_state runlogo_speed

  if { $runlogo_state < 0 } {
    .status.logo configure -bitmap "@$bd/rungate1.xbm"
    set runlogo_state 2
    after $runlogo_speed rkg_stepRunLogo
  }
}

proc tkg_editLogo {} {
  global bd runlogo_state

  .status.logo configure -bitmap "@$bd/gatelogo.xbm"
  set runlogo_state -1
}

after [expr $tkg_checkpointFreq * 1000] tkg_checkpointReq
proc tkg_checkpointReq {} {
  global tkg_wantCheckpoint tkg_checkpointEnabled tkg_checkpointFreq

  if { $tkg_checkpointEnabled } {
    set tkg_wantCheckpoint 1
  }
    after [expr $tkg_checkpointFreq * 1000] tkg_checkpointReq
}


frame .status.aux
label .status.file 
label .status.block
label .status.msg -font $body_font -relief groove -padx 5 -pady 5
label .status.logo -relief groove -bitmap "@$bd/gatelogo.xbm"

pack .status.logo -side right -ipadx 5 -ipady 5 -padx 5
pack .status.msg -side bottom -padx 10 -pady 5 -fill x
pack .status.aux -side right
pack .status.file .status.block -side left -padx 10 -pady 3 -fill x 

updateStatus

trace variable tkg_displayFile w updateStatus
trace variable tkg_currentBlock w updateStatus
trace variable tkg_modifiedFlag w updateStatus
trace variable tkg_statusMessage w updateStatus

helpon .status.logo "The tkgate logo."
helpon .status.msg "Messages from tkgate are displayed here."
helpon .status.block "The stack of modules being edited."
helpon .status.file "The current file being edited.  A '*' indicates\nthat the buffer has been modifed since\nthe last save."
