#   Copyright (C) 1987-1999 by Jeffery P. Hansen
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# Last edit by hansen on Mon Mar 20 15:14:52 2000
#

frame .tbar.f
button .tbar.f.new -bitmap "@$bd/file_new.b" -command tkg_new -takefocus 0
button .tbar.f.open -bitmap "@$bd/file_open.b" -command tkg_load -takefocus 0
button .tbar.f.save -bitmap "@$bd/file_save.b" -command tkg_saveCurrent -takefocus 0
button .tbar.f.print -bitmap "@$bd/file_print.b" -command tkg_printDlg -takefocus 0
pack .tbar.f.new .tbar.f.open .tbar.f.save .tbar.f.print -side left -pady 5

helpon .tbar.f.new {Clear the current circuit,
and start editing a new one.}
helpon .tbar.f.open {Open a circuit from a file.}
helpon .tbar.f.save {Save circuit to current file.}
helpon .tbar.f.print {Print current circuit.}

frame .tbar.m
radiobutton .tbar.m.mov -bitmap "@$bd/mov_curs.b" -indicatoron false -variable mode -value 1 -takefocus 0
radiobutton .tbar.m.del -bitmap "@$bd/del_curs.b" -indicatoron false -variable mode -value 3 -takefocus 0
radiobutton .tbar.m.cut -bitmap "@$bd/cut_curs.b" -indicatoron false -variable mode -value 0 -takefocus 0
radiobutton .tbar.m.inv -bitmap "@$bd/inv_curs.b" -indicatoron false -variable mode -value 2 -takefocus 0
radiobutton .tbar.m.siz -bitmap "@$bd/size_curs.b" -indicatoron false -variable mode -value 9 -takefocus 0
pack .tbar.m.mov .tbar.m.del .tbar.m.cut .tbar.m.inv .tbar.m.siz -side left -pady 5


helpon .tbar.m.mov {Move/Connect - By clicking and dragging you can:
  Set the position for a new gate
  Move gates
  Reposition wires
  Connect wires
By double-clicking you can:
  Edit gate properties
  Edit wire properties
  Edit port properties
  Edit comment text}

helpon .tbar.m.del {Delete Gate - Use this
tool to delete gates.}

helpon .tbar.m.cut {Cut Wire - Use this
tool to cut wires.}

helpon .tbar.m.inv {Invert - Use this tool to add
or remove inverters from gate ports.}

helpon .tbar.m.siz {Bit Width - Use this tool to change
the bit size of a wire.}

frame .tbar.b
button .tbar.b.open -bitmap "@$bd/blk_open.b" -command gat_openBox -takefocus 0
button .tbar.b.close -bitmap "@$bd/blk_close.b" -command gat_closeBox -takefocus 0
pack .tbar.b.open .tbar.b.close  -side left -pady 5

helpon .tbar.b.open {Open the selected module.}
helpon .tbar.b.close {Close the current module.}

frame .tbar.s
button .tbar.s.simgo -bitmap "@$bd/sim_go.b" -command tkg_simRun -takefocus 0
button .tbar.s.simpause -bitmap "@$bd/sim_pause.b" -command tkg_simStop -takefocus 0
button .tbar.s.simstep -bitmap "@$bd/sim_step.b" -command tkg_simStep -takefocus 0
button .tbar.s.simclock -bitmap "@$bd/sim_clock.b" -command tkg_simCycle -takefocus 0
button .tbar.s.simstop -bitmap "@$bd/sim_stop.b" -command gat_endSimulate -takefocus 0
pack .tbar.s.simgo .tbar.s.simpause .tbar.s.simstep .tbar.s.simclock .tbar.s.simstop -side left -pady 5

helpon .tbar.s.simgo {If no simulation is active, start
the simulation and execute any
initialization scripts.  If a
simulation is active, run simulation
continuously.}

helpon .tbar.s.simpause {Pause a continuously
running simulation.}

helpon .tbar.s.simstep {Step a fixed interval of time.
Open the simulation options
window to set the step size.}

helpon .tbar.s.simclock {Step a fixed number of clock
cycles.  Open the simulation options
window to set the step size.}

helpon .tbar.s.simstop {End the current simulation
and return to edit mode.}

frame .tbar.sc
button .tbar.sc.simbreak -bitmap "@$bd/sim_break.b" -takefocus 0 -command tkg_editBreakpoints
button .tbar.sc.simscript -bitmap "@$bd/sim_script.b" -takefocus 0 -command tkg_doSimScript
button .tbar.sc.simload -bitmap "@$bd/sim_load.b" -takefocus 0 -command tkg_simLoadMem
button .tbar.sc.simdump -bitmap "@$bd/sim_dump.b" -takefocus 0 -command tkg_simDumpMem
pack .tbar.sc.simbreak .tbar.sc.simscript .tbar.sc.simload .tbar.sc.simdump -side left -pady 5

helpon .tbar.sc.simbreak {Edit the current breakpoints.  Simulation
will be halted when a breakpoint condition
becomes true.}

helpon .tbar.sc.simscript {Execute a simultion script.}

helpon .tbar.sc.simload {Load memory with contents of
a .mem file.}

helpon .tbar.sc.simdump {Dump the contents of a memory
to a .mem file.}


pack .tbar.f .tbar.m .tbar.b .tbar.s .tbar.sc -side left -padx 5
